<?php
/**
 * Plugin Name: HM Estelam Rahvar
 * Plugin URI:  https://mahdimohebi.ir/my-plugins/
 * Description: Estelam Rahvar - [form_estelam]
 * Version:     8.4
 * Author:      Mahdi Mohebi
 * Author URI:  https://mahdimohebi.ir/
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Text Domain: estelam-rahvar
 * Domain Path: /languages
 * 
 */
 
 /*
 5.8 
 با اینتر کلید تایید و استعلام فعال می شود
 با زدن صفحات جدول ، جدول به شکل خودکار به بالا اسکرول می کند
 5.9
 آسپس چک مس شود و اگر از ایران نباشد پیام غیر فعال کردن فیلتر شکن به کاربر داده  می شود
 6.0
اگر بارکد اشتباهی باشه یا خلافی صفر باشه کلا در راهور یک پاسخ داره که میگه اطلاعات خلافی یافت نشد
برای این حالت ما به کاربر آلرت بدیم
 6.2
 با آپدیت ورژن پلاگین ، ورژن استایل ها و اسکریپن های پلاگین هم آپدیت می شود
 6.6
 رندر کپچا از فرم پیش لود شده استفاده می کند و از طریق ای جکس کپچا دیگر لود نمی شود- این باعث سرعت در رندر کپچا  شده است
 6.7
 به جای تشخیص فیلتر شکن یه تابع گذاشتیم لود یا عدم لود کپچا رو چک کنه که در صورت عدم لود به کاربر پیام بده
 7.1
 اسکریپت دیتا تیبل در هدر فراخوانی بشه که برای بقیه جدول های سایت هم از همین کتابخانه استفاده کنیم
  */
  

  
  
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}
define("estelam_rahvar_url", plugin_dir_url(__FILE__));
function estelam_rahvar_load_textdomain() {
  load_plugin_textdomain( 'estelam-rahvar', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
} 
add_action( 'plugins_loaded', 'estelam_rahvar_load_textdomain' );
//include_once('inc/simple_html_dom.php');


//define('STELAM_RAHVAR_DIR', dirname(__FILE__));
//require_once(STELAM_RAHVAR_DIR . '/inc/vendor/autoload.php');
//use GeoIp2\Database\Reader;






//include_once('inc/UserAgent.php');
//\Campo\UserAgent::random() 






if ( ! class_exists( 'estelam_rahvar' ) ) :
class estelam_rahvar {
	private static $settings;
	private function __construct() {
	} 
	public static function init_actions() {
		
		$plugin_data = get_file_data(__FILE__, [
			'Version' => 'Version',
			'TextDomain' => 'Text Domain'
		], 'plugin');
		
		//$estelam_rahvar_plugin_data = get_plugin_data( __FILE__ );
		define("estelam_rahvar_version",$plugin_data['Version']); 
		
		register_activation_hook( __FILE__, array( __CLASS__, 'activate' ) );
		register_deactivation_hook(__FILE__, array( __CLASS__, 'deactivat'));
		register_uninstall_hook( __FILE__, array( __CLASS__, 'uninstall' ) );
		add_shortcode('form_estelam', array( __CLASS__ , 'echo_shortcode'));
		add_action( 'update_option_estelam_rahvar_settings',  array( __CLASS__,'estelam_rahvar_options_updated'), 10, 2 );
		add_action( 'admin_menu', array( __CLASS__ , 'add_admin_menu' ) );
		add_action( 'admin_init', array( __CLASS__ , 'settings_init' ) );
		add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( __CLASS__, 'add_settings_link' ), 10, 2 );
		add_action( 'admin_enqueue_scripts', array( __CLASS__, 'enqueue_backend' ) );
		add_action( 'wp_enqueue_scripts', array( __CLASS__, 'enqueue_front' ) );
		add_action( 'wp_ajax_estelam_rahvar_ajax', array( __CLASS__,'ajax_request') );
		add_action( 'wp_ajax_nopriv_estelam_rahvar_ajax', array( __CLASS__,'ajax_request') );
		$settings = self::get_settings();
		//if ( $settings['xxx'] ) {
		//} else {
		//}
	} 
	public static function send_form_get_results( )
	{
		if(isset($_POST) and isset($_POST['action']) and $_POST['action']='estelam_rahvar_ajax'  ){
			if(isset($_POST['ajax_type']) and $_POST['ajax_type']=='load_rahvar_form'  ){
				//
			}elseif(isset($_POST['ajax_type']) and $_POST['ajax_type']=='submit_rahvar_form'){
				$hashtraghami = $_POST['hashtraghami'];
				$data = array("Identity" => array("Token"=>"70095808BB44498CAF28672DC5D2A66A"), "Parameters" =>array("BarCode"=>$hashtraghami));                                                                    
				$data_string = json_encode($data); 
				$new_connection = curl_init('https://core.inquiry.ayantech.ir/WebServices/Core.svc/TrafficFinesInquiry');
				curl_setopt($new_connection, CURLOPT_CONNECTTIMEOUT, 30);
				curl_setopt($new_connection, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($new_connection, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($new_connection, CURLOPT_FOLLOWLOCATION, 1);
				curl_setopt($new_connection, CURLOPT_HTTPHEADER, array(                                                                          
					'Content-Type: application/json',                                                                                
					'Accept: application/json')                                                                       
				); 
				curl_setopt($new_connection, CURLOPT_POSTFIELDS, $data_string);  				
				$new_result = curl_exec($new_connection);
				//print_r(curl_getinfo($new_connection));
				//echo curl_errno($new_connection) . '-' . curl_error($new_connection);
				curl_close($new_connection);
				
				//echo $hashtraghami;
				//echo '</br>';
				$result_array = json_decode($new_result, true); 
				//
				$Parameters = $result_array['Parameters'];
				$Status = $result_array['Status'];
				//
				$Details = $Parameters['Details'];//لیست خلافی ها
				$PlateNumber = $Parameters['PlateNumber'];//پلاک
				$TotalAmount = $Parameters['TotalAmount'];//جمع مبلغ
				//
				$Code = $Status['Code'];//کد وضعیت
				$Description = $Status['Description'];
				//var_dump( $Details);
				//echo '<br>';
				//var_dump( $PlateNumber);
				//echo '<br>';
				//var_dump( $TotalAmount);
				//echo '<br>';
				//var_dump( $Code);
				//echo '<br>';
				//var_dump( $Description);
				//echo '<br>';
				
				
				?>
				
				<div id="rahvar_api_status_description" style="display:none;"><?php echo $Description; ?></div>
				<div id="rahvar_api_status_code" style="display:none;"><?php echo $Code; ?></div>
				<div id="rahvar_api_count" style="display:none;"><?php if (!empty($Details)) { echo count($Details); } ?></div>
				
				<?php if (!empty($Details)) { ?>
				<table class="" id="t1" style="display:none;">
					<thead>
							<tr>
							<th scope="col">شرح تخلف</th>
							<th scope="col">نوع</th>
							<th scope="col" class="empty_td" style="display:none;" >کد تخلف	</th>
							<th scope="col">مبلغ(ریال)	</th>
							<th scope="col">محل تخلف</th>
							<th scope="col">شهر	</th>
							<th scope="col">تاریخ</th>
							<th scope="col" class="empty_td" style="display:none;" >سریال</th>
							<th scope="col" class="empty_td" style="display:none;" >بارکد</th>
							<th scope="col">پلاک</th>
							<th scope="col">شناسه پرداخت</th>
							<th scope="col">شناسه قبض</th>
							</tr>
						</thead>
					<tbody>
					<?php foreach ($Details as $array ) { ?>
						<tr>
							<td><?php echo $array['Type'] ?></td>
							<td><?php echo $array['Delivery'] ?></td>
							<td class="empty_td" style="display:none;" ></td>
							<td><?php echo $array['Amount'] ?></td>
							<td><?php echo $array['Location'] ?></td>
							<td><?php echo $array['City'] ?></td>
							<td><?php echo $array['DateTime'] ?></td>
							<td class="empty_td" style="display:none;" ></td>
							<td class="empty_td" style="display:none;" ></td>
							<td><?php echo $PlateNumber ?></td>
							<td><?php echo $array['PaymentID'] ?></td>
							<td><?php echo $array['BillID'] ?></td>
						</tr>
					<?php } ?>
					</tbody>
				</table>
				<?php } ?>
				
				<?php
				
				
				
				
				
				
				 
				
				
				
				
			}elseif(isset($_POST['ajax_type']) and $_POST['ajax_type']=='get_data_no_cpthca'){
				//var_dump($_POST['js_wizard_form']);
				$post_string = $_POST['js_wizard_form'];//قابل ارسال مستقیم 
				$q_array = array();//hashtraghami//aform//rc//duration//mobile//cptchid//capcha
				parse_str(  $_POST['js_wizard_form'], $q_array );
				$curl_connection = curl_init('http://khelafi.ir/inquiry.php');
				curl_setopt($curl_connection, CURLOPT_CONNECTTIMEOUT, 30);
				curl_setopt($curl_connection, CURLOPT_USERAGENT,$_SERVER['HTTP_USER_AGENT']);
				curl_setopt($curl_connection, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($curl_connection, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($curl_connection, CURLOPT_FOLLOWLOCATION, 1);
				curl_setopt($curl_connection, CURLOPT_POSTFIELDS, "id=".$q_array['hashtraghami']);
				$result = curl_exec($curl_connection);
				echo $result ;
				//print_r(curl_getinfo($curl_connection));
				//echo curl_errno($curl_connection) . '-' . curl_error($curl_connection);
				curl_close($curl_connection);
			}elseif(1){
				
			}
		}else{
		}
		//var_dump($_POST);
		
	}
	public static function add_admin_menu(  ) { 
		/*add_menu_page(
			__( 'Estelam Rahvar Options', 'estelam-rahvar' ),
			__( 'Estelam Rahvar', 'estelam-rahvar' ),
			'manage_options',
			'estelam_rahvar',
			array(__CLASS__,'estelam_rahvar_options_page'),
			'dashicons-info'
		);*/
		add_submenu_page(
			'options-general.php',
			__( 'Estelam Rahvar Options', 'estelam-rahvar' ),
			__( 'Estelam Rahvar', 'estelam-rahvar' ),
			'manage_options',
			'estelam_rahvar',
			array(__CLASS__,'estelam_rahvar_options_page'), 
		);
	}
	public static function settings_init(  ) { 
		register_setting( 'pluginPage', 'estelam_rahvar_settings' );
		add_settings_section(
			'estelam_rahvar_pluginPage_section', 
			__( 'Options', 'estelam-rahvar' ), 
			array( __CLASS__, 'estelam_rahvar_settings_section_callback'), 
			'pluginPage'
		);
		add_settings_field( 
			'ip_max_allowed_attempts', 
			__( 'Maximum Waiting Time (seconds) For Response', 'estelam-rahvar' ), 
			array( __CLASS__, 'ip_max_allowed_attempts_render'), 
			'pluginPage', 
			'estelam_rahvar_pluginPage_section' 
		);
		add_settings_field( 
			'ip_send_email_to', 
			__( 'Send Emails To :', 'estelam-rahvar' ), 
			array( __CLASS__, 'ip_send_email_to_render'), 
			'pluginPage', 
			'estelam_rahvar_pluginPage_section' 
		);
	}
	public static function ip_max_allowed_attempts_render(  ) { 
		$options = self::get_settings();
		?>
		<input type="number" name="estelam_rahvar_settings[ip_max_allowed_attempts]" class="ip_max_allowed_attempts" value="<?php echo $options['ip_max_allowed_attempts']; ?>" />
		<?php
	}
	public static function ip_send_email_to_render(  ) { 
		$options = self::get_settings();
		?>
		<input type="text" name="estelam_rahvar_settings[ip_send_email_to]" class="ip_send_email_to" value="<?php echo $options['ip_send_email_to']; ?>" />
		<?php
	}
	public static function estelam_rahvar_settings_section_callback(  ) { 
		echo __( 'Estelam Rahvar default options', 'estelam-rahvar' );
	}
	public static function estelam_rahvar_options_page(  ) { 
			?>
			<form action='options.php' method='post'>
				<h2><?php _e( 'ESTELAM RAHVAR',  'estelam-rahvar' ); ?></h2>
				<?php
				settings_fields( 'pluginPage' );
				do_settings_sections( 'pluginPage' );
				submit_button();
				?>
			</form>
			<?php
	}
	public static function ajax_request() {
		self::send_form_get_results();
		die(0);
	}
	public static function echo_shortcode($atts) { 
		extract( shortcode_atts( array(
			'expand' => '',
		), $atts) );
		global $paged;
		ob_start();
		
		$plugin_dir_url = plugin_dir_url( __FILE__ ); 
		?>
		
	 
		<script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>
		<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet">
		
		
		<script type="text/javascript" src="//cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js"></script>
		<link href="//cdn.datatables.net/1.10.20/css/jquery.dataTables.min.css" rel="stylesheet">
		
		
		<script type="text/javascript" src="//cdn.datatables.net/responsive/2.2.3/js/dataTables.responsive.min.js"></script>
		<link href="//cdn.datatables.net/responsive/2.2.3/css/responsive.dataTables.min.css" rel="stylesheet">
		
		<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/buttons.print.min.js"></script>
		<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/dataTables.buttons.min.js"></script>
		<link href="//cdn.datatables.net/buttons/1.6.0/css/buttons.dataTables.min.css" rel="stylesheet">
		

		
		
		
		
		<div class="panel panel-primary box-rahvar bax_rahvar" style="">
			<div class="panel-heading">استعلام خلافی خودرو</div>
			<div class="panel-body">
				<div class="stepwizard">
					<div class="stepwizard-row setup-panel">
					<div class="stepwizard-step">
					<a href="#step-1" type="button" class="btn btn-circle btn-default btn-primary">1</a>
					<p>کد هشت رقمی</p>
					</div>
					<div class="stepwizard-step">
					<a href="#step-3" type="button" class="btn btn-default btn-circle" disabled="disabled">3</a>
					<p>کپچا</p>
					</div>

					<div class="stepwizard-step">
					<a href="#step-4" type="button" class="btn btn-default btn-circle" disabled="disabled">4</a>
					<p>استعلام</p>
					</div>

					</div>
				</div>
				<div class="message_box_rahvar"></div>
				<form class="wizard-container" id="js-wizard-form" novalidate="novalidate" >
					<div class="setup-content" id="step-1" style="">
						<div class="col-xs-12">
							<div class="col-md-12">
								<div id="help" >
								
								</div>
								<div class="form-group">
									<input name="aform" value="add" type="hidden">
									<input name="rc" value="" type="hidden">
									<input type="hidden" name="duration" id="duration" value="39">
									<label for="hashtraghami" class="text-rahvar" style="font-size:16px;">برای دریافت خلافی خودرو کد هشت یا نه رقمی کارت خود را وارد کنید</label>
									<div class="input-group">
										<input class="form-control hashtraghami_class" type="text" name="hashtraghami" id="hashtraghami" placeholder="کد 8 رقمی کارت ماشین" required="">							
									</div>
								</div>
								<div id="wrap-rahvar-btn" class="group-btn">
									<a id="rahvar-btn" class="btn btn-primary  nextBtn " onclick="form_submit();">استعلام خلافی</a>
								</div>
								<!--button id="get_captcha_id" class="btn btn-primary  nextBtn btn-start" type="button" onclick="start_garb_captcha()">تایید</button-->
								<!-- button class="btn btn-primary  nextBtn pull-right" type="button">بعدی</button -->
								<img class="img-help" src="<?php echo estelam_rahvar_url; ?>images/car-card-min.jpg" alt="" style="display: block; margin: auto;margin-top: 15px;margin-bottom:10px;">
							</div>
						</div>
					</div>
					<div class="" id="" style="display: none;">
						<div class="col-xs-12">
							<div class="col-md-12">
								<div class="message_box_img"></div>
								<div class="form-group" id="box_img_captcha">
									<div id="captcha-img">
											<input id="cptchid" name="cptchid" type="hidden" value="">
											<img id="capimg" alt="متن درون تصویر را در جعبه متن زیر وارد نمائید" src="" width="200" height="60">
											<!-- data:image/gif;base64,R0lGODdhAQABAPAAAMPDwwAAACwAAAAAAQABAAACAkQBADs= -->
											<img data-lazyloaded="1" src="<?php echo estelam_rahvar_url; ?>images/refresh.gif" height="16" id="ch_capt" style="cursor:pointer " data-src="<?php echo estelam_rahvar_url; ?>images/refresh.gif" width="18" onclick=""><noscript><img height="16" id="ch_capt" style="cursor:pointer " src="<?php echo estelam_rahvar_url; ?>images/refresh.gif" width="18" onclick=""></noscript>
										</div>
										<label for="hashtraghami" class="text-rahvar"   style=" padding-bottom: 0;    display: block;">متن موجود در تصویر را وارد کنید </label>
										<label for="hashtraghami" class="text-rahvar" style=" padding-top: 0;    display: block;">به کوچک یا بزرگ نوشتن حروف حساس نیست</label>
										<input class="form-control capcha_class" type="text" name="capcha" id="capcha" value="xh7xn" placeholder="متن تصویر را وارد کنید" required="required">
								</div>
								<div id="wrap-rahvar-btn" class="group-btn">
									<a id="rahvar-btn" class="btn btn-primary  nextBtn " onclick="form_submit();">استعلام خلافی</a>
									<button class="btn btn-danger  previewBtn" type="button">بازگشت</button>
								</div>

							</div>
						</div>

					</div>
					<div class="setup-content" id="step-3" style="display: none;">
						<div class="col-xs-12">
							<div class="col-md-12">
								<div class="message_box"></div>
								<div class="col-md-12 btn_box_above_table">
								</div>
									<table class="table table-striped table-responsive display responsive nowrap dt-responsive" id="table_final" style="display:none;">
										<thead>
												<tr>
												<th scope="col">شرح تخلف</th>
												<th scope="col">نوع</th>
												<th scope="col" class="empty_td" style="display:none;" >کد تخلف	</th>
												<th scope="col">مبلغ(ریال)	</th>
												<th scope="col">محل تخلف</th>
												<th scope="col">شهر	</th>
												<th scope="col">تاریخ</th>
												<th scope="col" class="empty_td" style="display:none;" >سریال</th>
												<th scope="col" class="empty_td" style="display:none;" >بارکد</th>
												<th scope="col">پلاک</th>
												<th scope="col">شناسه پرداخت</th>
												<th scope="col">شناسه قبض</th>
												</tr>
											</thead>
										<tbody>
										</tbody>
								  </table>
							</div>
						</div>
						<div class="tab-pane" id="tab5">
						</div>
					</div>
				</form>
			</div>
			<div id="rahvar_page" style="display:none !important;">
				<?php /*
				$curl_connection = curl_init('http://estelam.rahvar120.ir/index.jsp?pageid=2371666&p=1');
				curl_setopt($curl_connection, CURLOPT_CONNECTTIMEOUT, 5);
				curl_setopt($curl_connection, CURLOPT_USERAGENT, 
				  "Mozilla/6.0 (compatible; MSIE 6.0; Windows NT 5.1)");
				curl_setopt($curl_connection, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($curl_connection, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($curl_connection, CURLOPT_FOLLOWLOCATION, 1);
				$results = curl_exec($curl_connection);
				curl_close($curl_connection);
				$dom = new DomDocument;
				$dom->validateOnParse = true;
				$internalErrors = libxml_use_internal_errors(true);
				$dom->loadHTML('<?xml encoding="utf-8" ?>' . $results);
				libxml_use_internal_errors($internalErrors);
				$el = $dom->getElementById("advformid");
				if(isset($el)){
					$elString = $el->C14N();
					echo $elString;
				}else{
					//echo '<script>alert("خطا در پیش بارگزاری راهور");</script>';
					//var_dump($results);
					//echo "rahvar not loaded";
				} */
				?>
			</div>
			<div id="sr_ajax_target" style="display:none;"></div>
			<div id="result_table" style="display:none;"></div>
				
		</div>

		<?php
		$out = ob_get_clean();
		return $out;
	}
	
	public static function curl_exec_follow($ch, &$maxredirect = null) {
	  // we emulate a browser here since some websites detect
	  // us as a bot and don't let us do our job
	  $user_agent = "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5)".
					" Gecko/20041107 Firefox/1.0";
	  curl_setopt($ch, CURLOPT_USERAGENT, $user_agent );
	  $mr = $maxredirect === null ? 5 : intval($maxredirect);
	  //if (!ini_get('open_basedir') && !ini_get('safe_mode')) {
	  if (1) {  
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $mr > 0);
		curl_setopt($ch, CURLOPT_MAXREDIRS, $mr);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT ,7); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 7);
		//curl_setopt($ch, CURLOPT_URL, '');
	  } else {
		echo '<div class="we_debug"> CURLOPT_FOLLOWLOCATION is false </div>';
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
		if ($mr > 0)
		{
			echo "dddddddddddddddddddddd";
		  $original_url = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL);
		  $newurl = $original_url;
		  $rch = curl_copy_handle($ch);
		  curl_setopt($rch, CURLOPT_HEADER, true);
		  curl_setopt($rch, CURLOPT_VERBOSE, true);
		  curl_setopt($rch, CURLOPT_CONNECTTIMEOUT ,7); 
		  curl_setopt($rch, CURLOPT_TIMEOUT, 7);
		  //curl_setopt($rch, CURLOPT_NOBODY, true); //do not filter body never - ever
		  curl_setopt($rch, CURLOPT_FORBID_REUSE, false);
		  do
		  {
			curl_setopt($rch, CURLOPT_URL, $newurl);
			$response = curl_exec($rch);
			$header_size = curl_getinfo($rch, CURLINFO_HEADER_SIZE);
			$header = substr($response, 0, $header_size); //this line is very important
			$body = substr($response, $header_size);
			//var_dump( $header);
			if (curl_errno($rch)) {
			  $code = 0;
			   echo '<div class="we_debug" >error:' . curl_error($rch).'</div>';
			} else {
			  $code = curl_getinfo($rch, CURLINFO_HTTP_CODE);
			  if ($code == 301 || $code == 302) {
				preg_match('/Location:(.*?)\n/i', $header, $matches);
				$newurl = trim(array_pop($matches));
				// if no scheme is present then the new url is a
				// relative path and thus needs some extra care
				if(!preg_match("/^https?:/i", $newurl)){
				  $newurl = $original_url . $newurl;
				}   
			  } else {
				$code = 0;
			  }
			}
		  } while ($code && --$mr);
		  curl_close($rch);
		  if (!$mr)
		  {
			if ($maxredirect === null)
			trigger_error('Too many redirects.', E_USER_WARNING);
			else
			$maxredirect = 0;
			return false;
		  }
		  curl_setopt($ch, CURLOPT_URL, $newurl);
		}
	  }
	  ///////////////////////////
	   $curl_result = curl_exec($ch);
	   if (curl_errno($ch)) {
			   echo '<div class="we_debug" >error:' . curl_error($ch).'</div>';
				echo '<div class="we_debug" >this means the requested web page currently is unavailable</div>';
			}
	   $info = curl_getinfo($ch);
	   $outpt_array['1'] = $curl_result;
	   $outpt_array['2'] = $info;
	   return $outpt_array;
	}
	
	public static function download_page_on_safe_mode($href){
		//$href ='http://11687.ir/';
		//$href = self::sanitizeUrl($href);	
		$ch = curl_init($href);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$outpted_array = self::curl_exec_follow($ch);
		curl_close($ch);
		return $outpted_array;
	}
	
	private static function get_settings() {
		self::$settings = get_option( 'estelam_rahvar_settings' );
		return self::$settings;
	}
	public static function get_ip() {
		$ip = '';
		if ( isset( $_SERVER ) ) {
			$sever_vars = array( 'HTTP_X_REAL_IP', 'HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'REMOTE_ADDR' );
			foreach( $sever_vars as $var ) {
				if ( isset( $_SERVER[ $var ] ) && ! empty( $_SERVER[ $var ] ) ) {
					if ( filter_var( $_SERVER[ $var ], FILTER_VALIDATE_IP ) ) {
						$ip = $_SERVER[ $var ];
						break;
					} else { /* if proxy */
						$ip_array = explode( ',', $_SERVER[ $var ] );
						if ( is_array( $ip_array ) && ! empty( $ip_array ) && filter_var( $ip_array[0], FILTER_VALIDATE_IP ) ) {
							$ip = $ip_array[0];
							break;
						}
					}
				}
			}
		}
		return $ip; 
	}
	public static function enqueue_backend() {
		 
		
		wp_enqueue_script("jquery");
		wp_enqueue_style('back_css', plugins_url('assets/back.css',__FILE__ ),'',estelam_rahvar_version);
		wp_enqueue_script('back_js', plugins_url('assets/back.js',__FILE__ ),array('jquery'),estelam_rahvar_version);
	}
	public static function enqueue_front(){
		
		wp_enqueue_script("jquery");
		wp_enqueue_script('sr_front_js', plugins_url('assets/front.js',__FILE__ ),array('jquery'),estelam_rahvar_version);
		$data = array('name_1'   => admin_url( 'admin-ajax.php' ),'a_value' => '10');
		wp_localize_script('sr_front_js', 'pefix_handel', $data);
		wp_enqueue_style('sr_front_css', plugins_url('assets/front.css',__FILE__ ),'',estelam_rahvar_version);
		wp_enqueue_style('sr_front_csr_rtl', plugins_url('assets/front_rtl.css',__FILE__ ),'',estelam_rahvar_version);
		
		//wp_enqueue_script('sr_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js');
		//wp_enqueue_style('sr_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css');
		
		//wp_enqueue_script('sr_prefix_datatables', '//cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js',array('jquery'));
		//wp_enqueue_style('sr_datatables', '//cdn.datatables.net/1.10.20/css/jquery.dataTables.min.css');
		
		//wp_enqueue_script('sr_prefix_datatables_responsive', '//cdn.datatables.net/responsive/2.2.3/js/dataTables.responsive.min.js',array('jquery'));
		//wp_enqueue_style('sr_datatables_responsive', '//cdn.datatables.net/responsive/2.2.3/css/responsive.dataTables.min.css');
		
		//wp_enqueue_script('sr_prefix_datatables_print', '//cdn.datatables.net/buttons/1.6.0/js/buttons.print.min.js',array('jquery'));
		//wp_enqueue_script('sr_prefix_datatables_buttons', '//cdn.datatables.net/buttons/1.6.0/js/dataTables.buttons.min.js',array('jquery'));
		//wp_enqueue_style('sr_datatables_buttons', '//cdn.datatables.net/buttons/1.6.0/css/buttons.dataTables.min.css');
		
		
		 
	}
	public static function add_settings_link( $links, $file ) {
		$settings = self::get_settings();
		if ( current_user_can( 'manage_options' ) ) {
			$url = admin_url( 'edit.php?post_type=blocked_ip&page=estelam_rahvar' );
			$links = (array) $links;
			$links[] = sprintf( '<a href="%s">%s</a>', $url, __( 'Settings', 'estelam-rahvar' ) );
		}
		return $links;
	}
	public static function activate() {
		if (! wp_next_scheduled ( 'scheduled_estelam_rahvar_email' )) {
			$settings = self::get_settings();
			wp_schedule_event(time(), $settings['ip_send_report_period'], 'scheduled_estelam_rahvar_email');
		}
		$settings = array(
			'ip_max_allowed_attempts' => get_option( 'ip_max_allowed_attempts','6' ),
			'ip_reset_attempts_after' => get_option( 'ip_reset_attempts_after','23' ),
			'ip_send_warning' => get_option( 'ip_send_warning','yes' ),
			'ip_send_warning_after_x_attempts' => get_option( 'ip_send_warning_after_x_attempts','3' ),
			'ip_send_report' => get_option( 'ip_send_report','yes' ),
			'ip_send_report_period' => get_option( 'ip_send_report_period','weekly' ),
			'ip_send_email_to' => get_option( 'ip_send_email_to',get_option( 'admin_email' ) ),
		);
		add_option( 'estelam_rahvar_settings', $settings );
	}
	public static function deactivat() {
	}
	public static function uninstall() {
		delete_option( 'estelam_rahvar_settings' );
	}
	public static function estelam_rahvar_options_updated($old_value, $value ) {
		if($old_value['ip_send_report_period'] !== $value['ip_send_report_period']){
		}
	}
}
add_action( 'plugins_loaded', array( 'estelam_rahvar', 'init_actions' ) );
register_activation_hook( __FILE__, array( 'estelam_rahvar', 'activate' ) );
register_deactivation_hook(__FILE__, array( 'estelam_rahvar', 'deactivat'));
endif;
function my_admin_footer_function() {
	//update_option( 'tttttttttttt', $data );
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export(get_option( 'tttttttttttt',true ), true) . "\n ?>");
	?></div><?php 
	delete_option( 'tttttttttttt');
}
//add_action('admin_footer', 'my_admin_footer_function');

function test_sss(){
	
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export('' , true) . "\n ?>");
	?></div><?php 
	
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export('' , true) . "\n ?>");
	?></div><?php 
}